From bb762d4ddd9ca5018da13c4233b6170364250b20 Mon Sep 17 00:00:00 2001
From: Hannes Domani <ssbssa@yahoo.de>
Date: Wed, 28 Jan 2009 22:07:14 +0100
Subject: [PATCH] fix h264 encoding in windows

---
 configure.ac                                     |   16 ++++++++++++++++
 extras/contrib/src/Makefile                      |    1 +
 extras/contrib/src/Patches/pthreads-detach.patch |   12 ++++++++++++
 3 files changed, 29 insertions(+), 0 deletions(-)
 create mode 100644 extras/contrib/src/Patches/pthreads-detach.patch

diff --git a/configure.ac b/configure.ac
index 5e93a8f..7ce0b52 100644
--- a/configure.ac
+++ b/configure.ac
@@ -3657,6 +3657,14 @@ if test "${enable_x264}" != "no"; then
         VLC_ADD_PLUGIN([x264])
         VLC_ADD_LDFLAGS([x264],[${X264_LIBS}])
         VLC_ADD_CFLAGS([x264],[${X264_CFLAGS}])
+        if echo ${X264_LIBS} |grep -q 'pthreadGC2'; then
+          LIBS_save="${LIBS}"
+          LIBS="-lwsock32"
+          AC_CHECK_LIB(pthreadGC2, pthread_win32_process_attach_np, [
+            VLC_ADD_CFLAGS([x264], [-DPTW32_STATIC_LIB])
+          ])
+          LIBS="${LIBS_save}"
+        fi
       ],[
         AC_MSG_ERROR([the specified tree hasn't been compiled])
       ])
@@ -3670,6 +3678,14 @@ if test "${enable_x264}" != "no"; then
         VLC_ADD_PLUGIN([x264])
         VLC_ADD_LDFLAGS([x264],[${X264_LIBS}])
         VLC_ADD_CFLAGS([x264],[${X264_CFLAGS}])
+        if echo ${X264_LIBS} |grep -q 'pthreadGC2'; then
+          LIBS_save="${LIBS}"
+          LIBS="-lwsock32"
+          AC_CHECK_LIB(pthreadGC2, pthread_win32_process_attach_np, [
+            VLC_ADD_CFLAGS([x264], [-DPTW32_STATIC_LIB])
+          ])
+          LIBS="${LIBS_save}"
+        fi
       ],[
         if test "${enable_x264}" = "yes"; then
             AC_MSG_ERROR([Could not find libx264 on your system: you may get it from http://www.videolan.org/x264.html])
diff --git a/extras/contrib/src/Makefile b/extras/contrib/src/Makefile
index 7cc7a0c..b52ce35 100644
--- a/extras/contrib/src/Makefile
+++ b/extras/contrib/src/Makefile
@@ -2390,6 +2390,7 @@ pthreads-w32-$(PTHREADS_VERSION)-release.tar.gz:
 
 pthreads: pthreads-w32-$(PTHREADS_VERSION)-release.tar.gz
 	$(EXTRACT_GZ)
+	(cd $@; patch -p0 < ../Patches/pthreads-detach.patch)
 
 .pthreads: pthreads
 	(cd $<; $(HOSTCC) make $(PTHREADSCONF) GC GC-static && mkdir -p $(PREFIX)/include && cp -v pthread.h sched.h semaphore.h $(PREFIX)/include/ && mkdir -p $(PREFIX)/lib && cp -v *.{a,dll} $(PREFIX)/lib/)
diff --git a/extras/contrib/src/Patches/pthreads-detach.patch b/extras/contrib/src/Patches/pthreads-detach.patch
new file mode 100644
index 0000000..73e9f36
--- /dev/null
+++ b/extras/contrib/src/Patches/pthreads-detach.patch
@@ -0,0 +1,12 @@
+--- ptw32_processTerminate.c	Mon Jan 26 18:00:34 2009
++++ ptw32_processTerminate.c	Mon Jan 26 18:00:42 2009
+@@ -96,6 +96,9 @@
+ 	  tp = tpNext;
+ 	}
+ 
++      ptw32_threadReuseTop = PTW32_THREAD_REUSE_EMPTY;
++      ptw32_threadReuseBottom = PTW32_THREAD_REUSE_EMPTY;
++
+       LeaveCriticalSection (&ptw32_thread_reuse_lock);
+ 
+       /* 
-- 
1.5.6.1.1071.g76fb

